// File: StudentTest.java
// Demonstrate some of the functionality of the Heirarchical Student demo

import java.io.*;

public class StudentTest {
   
   static int MaxSize=5 ;

   static BufferedReader DataInput=new BufferedReader
							(new InputStreamReader(System.in));
   
 static int ReadInt() throws java.io.IOException
 {BufferedReader DataIn = new 
			 BufferedReader(new InputStreamReader(System.in));
  String Input=DataIn.readLine();
  return (Integer.valueOf(Input).intValue());
 }
 
public static char ReadChar() throws java.io.IOException
{ BufferedReader DataIn=new BufferedReader(new InputStreamReader(System.in));
  String Line;
  do 
	Line=DataIn.readLine().trim();
  while (Line.length()==0);
  return((Line.toUpperCase().toCharArray())[0]);
}


static char GetChoice(String OK)  throws java.io.IOException
{char Reply;
 
 do {
  Reply=ReadChar();
 } while (OK.indexOf(Reply,0)==-1);
 return(Reply);
}

static void GetValues(Student[] List,IntegerObject ListSize)
                                             throws java.io.IOException
{
  String Name;
  int Points,Hours ;
 
  do {
     System.out.print( "Enter Student Name >");
     System.out.flush();
     do 
      	Name=DataInput.readLine().trim();
     while (Name.length()==0);
     if  (!Name.equals(".")) {
       System.out.print("Hours? >");
       System.out.flush();
       Hours=ReadInt();
       System.out.print("Points? >");
       System.out.flush();
       Points=ReadInt();
  
       List[ListSize.GetValue()]=new Student(Name,Hours,Points);
       ListSize.Increment(1);
     }
   } while (ListSize.GetValue()<MaxSize && !(Name.equals(".")));
 }

 // Print Student Header
 static void PrintStudentHeader() throws java.io.IOException
 {
    System.out.println("Sorted list of Students\n");
    System.out.println("\nStudent Name        Hours      GPA\n");
 }

static void SortValues(Student[] List,IntegerObject ListSize)
{ //System.out.println("SORTING");
  for  (int i=0;i < ListSize.GetValue() ;i++)
  {
    int j=i;
    String s =List[i].GetName();
    Student temp=List[i];    
    while (( j>0) && (Student.CompareNames(List[j-1],temp) > 0))
    {       
           List[j]=List[j-1];
	   j--;
    }
    List[j]=temp;
  }       
//System.out.println("DONE");
}


static void SearchValues(Student[] List,IntegerObject ListSize,String str,
                           IntegerObject Position )
{ //System.out.println("SEARCHING");
  int i=-1;
  int j = ListSize.GetValue();
  int k=0;
  Student temp = new Student(str);
  boolean matchName = false;
    while ( (i+1<j)&& (!matchName) )
    {
     k=(i+j)/2;
     int result = Student.CompareNames(List[k],temp);
     if (result == 0)
       matchName = true;
     else if (result < 0)
        i=k;
     else 
        j = k;
    }
    
    
    if (matchName)
       Position.SetValue(k);
    else
       Position.SetValue(-1); 
       
// System.out.println("DONE");      
}


static void ReportValues(Student[] List,IntegerObject ListSize)
                                             throws java.io.IOException
{ PrintStudentHeader();                                            
  for  (int i=0;i < ListSize.GetValue() ;i++)
     Student.PrintStudentInfo(List[i]);
}   

static void FailedSearch() throws java.io.IOException
{ 
  System.out.println(" No such Student Info Found in database ");
} 

static void SuccessSearch(Student [] List,IntegerObject Position) throws java.io.IOException
{ 
  System.out.println(" Student Info Requested from database :");
  List[Position.GetValue()].PrintStudentInfo();
} 

      
public static void main(String[] args) throws java.io.IOException
{
 char Choice;
 String str ;
 Student[] StudentList = new Student[MaxSize];
 IntegerObject NumberOfValues=new IntegerObject(),
               Position = new IntegerObject();
 
 GetValues(StudentList,NumberOfValues);
 SortValues(StudentList,NumberOfValues);
 ReportValues(StudentList,NumberOfValues);
 
 while ( true ) 
 {   
     System.out.println(" Info Requested for Student:\n");
     System.out.print(" Name>");
     System.out.flush();
     str = DataInput.readLine();
     if (str.equals(".")) break;
     
     SearchValues(StudentList,NumberOfValues,str,Position);
     if (Position.GetValue() < 0)
         FailedSearch();
	 else {
        SuccessSearch(StudentList,Position);
		System.out.println("Add a Course for this Student?");
		char Answer;
		while ((Answer=GetChoice("YN"))=='Y') {
			System.out.print("Department? >");
			System.out.flush();
			String Dept=DataInput.readLine();
			System.out.print("Number? >");
			System.out.flush();
			int Number=ReadInt();
			System.out.print("Hours? >");
			System.out.flush();
			int Hours=ReadInt();
			System.out.print("Grade? >");
			System.out.flush();
			char Grade=ReadChar();
			
			StudentList[Position.GetValue()].AddClass(Dept,Number,Hours,Grade);
			System.out.println("Add another Course for this Student?");
		}	
		StudentList[Position.GetValue()].PrintStudentInfo();
	 } // else		
	 
 }

} // end of main()


} // end class

